Index: /gli/trunk/src/org/greenstone/gatherer/Gatherer.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/Gatherer.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/Gatherer.java	(revision 17612)
@@ -85,4 +85,5 @@
 
     static private Dimension size = new Dimension(800, 540);
+    static public RemoteGreenstoneServer remoteGreenstoneServer = null;
 
     /** Has the exit flag been set? */
@@ -299,9 +300,12 @@
 	    // Finally, we're ready to find out the version of the remote Greenstone server 
 	    if(isGsdlRemote) {
+		// instantiate the RemoteGreenstoneServer object first
+		remoteGreenstoneServer = new RemoteGreenstoneServer();
+
 		int greenstoneVersion = 2;
 		requestGLIServerURL();
 		gliserver_url_string = Configuration.gliserver_url.toString();
 		
-		greenstoneVersion = RemoteGreenstoneServer.getGreenstoneVersion();
+		greenstoneVersion = remoteGreenstoneServer.getGreenstoneVersion();
 		// Display the version to make error reports a lot more useful
 		System.err.println("Remote Greenstone server version: " + greenstoneVersion);
@@ -316,5 +320,5 @@
 		    library_url_string = fedora_info.getLibraryURL();
 		} else {
-		    library_url_string = RemoteGreenstoneServer.getLibraryURL(Configuration.gliserver_url.toString());
+		    library_url_string = remoteGreenstoneServer.getLibraryURL(Configuration.gliserver_url.toString());
 		}
 	    }
@@ -472,5 +476,5 @@
 	// If using a remote Greenstone we need to download the collection configurations now
 	if (Gatherer.isGsdlRemote) {
-	    if (RemoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+	    if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
 		// !! Something went wrong downloading the collection configurations
 		System.err.println("Error: Could not download collection configurations.");
@@ -551,5 +555,5 @@
 	// If using a remote Greenstone we need to download the collection configurations now
 	if (Gatherer.isGsdlRemote) {
-	    if (RemoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
+	    if (remoteGreenstoneServer.downloadCollectionConfigurations().equals("")) {
 		// !! Something went wrong downloading the collection configurations
 		System.err.println("Error: Could not download collection configurations.");
@@ -616,5 +620,5 @@
 	// If we're using a remote Greenstone server we need to make sure that all jobs have completed first
 	if (isGsdlRemote) {
-	    RemoteGreenstoneServer.exit();
+	    remoteGreenstoneServer.exit();
 	}
 
Index: /gli/trunk/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/CollectionConfiguration.java	(revision 17612)
@@ -3707,5 +3707,5 @@
         // If we're using a remote Greenstone server, upload the new 'collectionConfig.xml' file
         if (Gatherer.isGsdlRemote) {
-            RemoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
+            Gatherer.remoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
         }
         
@@ -3799,5 +3799,5 @@
             // If we're using a remote Greenstone server, upload the new collect.cfg file
             if (Gatherer.isGsdlRemote) {
-                RemoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
+                Gatherer.remoteGreenstoneServer.uploadCollectionFile (collection_name, collect_cfg_file);
             }
         }
Index: /gli/trunk/src/org/greenstone/gatherer/cdm/GeneralManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/GeneralManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/GeneralManager.java	(revision 17612)
@@ -344,5 +344,6 @@
 			    // If we're using a remote Greenstone server, upload the image
 			    if (Gatherer.isGsdlRemote) {
-				RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), collection_image_file);
+				Gatherer.remoteGreenstoneServer.uploadCollectionFile(
+                                   CollectionManager.getLoadedCollectionName(), collection_image_file);
 			    }
 			}
Index: /gli/trunk/src/org/greenstone/gatherer/cdm/MacrosManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/cdm/MacrosManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/cdm/MacrosManager.java	(revision 17612)
@@ -217,5 +217,5 @@
 		// Users need to wait until the upload has finished before pressing Preview Collection!
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), extra_dm_file);
+		    Gatherer.remoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), extra_dm_file);
 		}
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/collection/CollectionManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 17612)
@@ -379,5 +379,5 @@
 	// Remove the lock file on the server
 	if (Gatherer.isGsdlRemote) {
-	    RemoteGreenstoneServer.deleteCollectionFile(collection.getName(), lock_file);
+	    Gatherer.remoteGreenstoneServer.deleteCollectionFile(collection.getName(), lock_file);
 	}
 
@@ -547,5 +547,5 @@
 		collection_import_directory.mkdirs();
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.newCollectionDirectory(name, collection_import_directory);
+		    Gatherer.remoteGreenstoneServer.newCollectionDirectory(name, collection_import_directory);
 		}
 	    }
@@ -581,5 +581,5 @@
 		if (Gatherer.isGsdlRemote) {
 		    String base_collection_name = base_collection_directory.getName();
-		    RemoteGreenstoneServer.downloadCollection(base_collection_name);
+		    Gatherer.remoteGreenstoneServer.downloadCollection(base_collection_name);
 		}
 
@@ -765,5 +765,5 @@
 	// Delete the collection on the server if we're using a remote Greenstone
 	if (Gatherer.isGsdlRemote) {
-	    RemoteGreenstoneServer.deleteCollection(collection_name);
+	    Gatherer.remoteGreenstoneServer.deleteCollection(collection_name);
 	}
 
@@ -1056,5 +1056,5 @@
 		// If we're using a remote Greenstone server, upload the metadata file
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.uploadCollectionFile(collection.getName(), metadata_set_file);
+		    Gatherer.remoteGreenstoneServer.uploadCollectionFile(collection.getName(), metadata_set_file);
 		}
 	    }
@@ -1122,5 +1122,5 @@
 	if (Gatherer.isGsdlRemote) {
 	    String collection_name = location.substring(location.lastIndexOf(File.separator) + 1, location.length() - ".col".length());
-	    if (RemoteGreenstoneServer.downloadCollection(collection_name).equals("")) {
+	    if (Gatherer.remoteGreenstoneServer.downloadCollection(collection_name).equals("")) {
 		return;
 	    }
@@ -1618,5 +1618,5 @@
 	    // If we're using a remote Greenstone server, delete the metadata file on the server
 	    if (Gatherer.isGsdlRemote) {
-		RemoteGreenstoneServer.deleteCollectionFile(collection.getName(), metadata_set_file);
+		Gatherer.remoteGreenstoneServer.deleteCollectionFile(collection.getName(), metadata_set_file);
 	    }
 	}
@@ -1750,6 +1750,8 @@
 
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.deleteCollectionFile(collection.getName(), new File(getLoadedCollectionIndexDirectoryPath()));
-		    RemoteGreenstoneServer.moveCollectionFile(collection.getName(), new File(getLoadedCollectionBuildingDirectoryPath()), new File(getLoadedCollectionIndexDirectoryPath()));
+		    Gatherer.remoteGreenstoneServer.deleteCollectionFile(
+                             collection.getName(), new File(getLoadedCollectionIndexDirectoryPath()));
+		    Gatherer.remoteGreenstoneServer.moveCollectionFile(collection.getName(), 
+                    new File(getLoadedCollectionBuildingDirectoryPath()), new File(getLoadedCollectionIndexDirectoryPath()));
 		}
 
Index: /gli/trunk/src/org/greenstone/gatherer/collection/ScriptOptions.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/collection/ScriptOptions.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/collection/ScriptOptions.java	(revision 17612)
@@ -225,5 +225,5 @@
 
 	    if (Gatherer.isGsdlRemote) {
-		String script_output = RemoteGreenstoneServer.getScriptOptions(filename, "");
+		String script_output = Gatherer.remoteGreenstoneServer.getScriptOptions(filename, "");
 		document = XMLTools.parseXML(new StringReader(script_output));
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/file/FileManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/file/FileManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/file/FileManager.java	(revision 17612)
@@ -180,10 +180,10 @@
 			    source_files[i] = source_nodes[i].getFile();
 			}
-			RemoteGreenstoneServer.uploadFilesIntoCollection(collection_name, source_files, target_node.getFile());
+			Gatherer.remoteGreenstoneServer.uploadFilesIntoCollection(collection_name, source_files, target_node.getFile());
 		    }
 		    else if (type == FileJob.DELETE) {
 			// Deletes: delete each top-level file/directory one at a time
 			for (int i = 0; i < source_nodes.length; i++) {
-			    RemoteGreenstoneServer.deleteCollectionFile(collection_name, source_nodes[i].getFile());
+			    Gatherer.remoteGreenstoneServer.deleteCollectionFile(collection_name, source_nodes[i].getFile());
 			}
 		    }
@@ -191,5 +191,6 @@
 			// Moves: move each top-level file/directory one at a time
 			for (int i = 0; i < source_nodes.length; i++) {
-			    RemoteGreenstoneServer.moveCollectionFile(collection_name, source_nodes[i].getFile(), target_node.getFile());
+			    Gatherer.remoteGreenstoneServer.moveCollectionFile(
+                                     collection_name, source_nodes[i].getFile(), target_node.getFile());
 			}
 		    }
@@ -272,5 +273,6 @@
 		// ... but only if it is inside the collection and we haven't already downloaded it
 		if (file.getAbsolutePath().startsWith(Gatherer.getCollectDirectoryPath()) && file.length() == 0) {
-		    if (RemoteGreenstoneServer.downloadCollectionFile(CollectionManager.getLoadedCollectionName(), file).equals("")) {
+		    if (Gatherer.remoteGreenstoneServer.downloadCollectionFile(
+                                 CollectionManager.getLoadedCollectionName(), file).equals("")) {
 			// Something has gone wrong downloading the file
 			return;
@@ -347,5 +349,6 @@
 			    folder_file.createNewFile();
 			    if (Gatherer.isGsdlRemote) {
-				RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), folder_file);
+				Gatherer.remoteGreenstoneServer.uploadCollectionFile(
+                                         CollectionManager.getLoadedCollectionName(), folder_file);
 			    }
 			}
@@ -353,5 +356,6 @@
 			    folder_file.mkdirs();
 			    if (Gatherer.isGsdlRemote) {
-				RemoteGreenstoneServer.newCollectionDirectory(CollectionManager.getLoadedCollectionName(), folder_file);
+				Gatherer.remoteGreenstoneServer.newCollectionDirectory(
+                                         CollectionManager.getLoadedCollectionName(), folder_file);
 			    }
 			}
@@ -413,5 +417,6 @@
 		file_queue.addJob(System.currentTimeMillis(), collection_tree, new FileNode[] { collection_tree_node }, collection_tree, new_collection_tree_node, FileJob.RENAME);
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.moveCollectionFile(CollectionManager.getLoadedCollectionName(), collection_file, new_collection_file);
+		    Gatherer.remoteGreenstoneServer.moveCollectionFile(
+                             CollectionManager.getLoadedCollectionName(), collection_file, new_collection_file);
 		}
 	    }
@@ -462,5 +467,6 @@
 	    file_queue.addJob(System.currentTimeMillis(), Gatherer.g_man.gather_pane.workspace_tree, new FileNode[] { source_node }, collection_tree, (FileNode)collection_tree_node.getParent(),  FileJob.COPY_FILE_ONLY);
 	    if (Gatherer.isGsdlRemote) {
-		RemoteGreenstoneServer.uploadFilesIntoCollection(CollectionManager.getLoadedCollectionName(), new File[] { new_file }, target_directory);
+		Gatherer.remoteGreenstoneServer.uploadFilesIntoCollection(
+                         CollectionManager.getLoadedCollectionName(), new File[] { new_file }, target_directory);
 	    }
 	    // do a replace of old file with new file
Index: /gli/trunk/src/org/greenstone/gatherer/greenstone/Classifiers.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/greenstone/Classifiers.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/greenstone/Classifiers.java	(revision 17612)
@@ -134,5 +134,5 @@
 		    classinfo_options += "&collection=" + collection_name;
 		}
-		classinfo_xml = RemoteGreenstoneServer.getScriptOptions("classinfo.pl", classinfo_options);
+		classinfo_xml = Gatherer.remoteGreenstoneServer.getScriptOptions("classinfo.pl", classinfo_options);
 	    }
 	    else {
@@ -195,5 +195,5 @@
 		    classinfo_options += "&collection=" + collection_name;
 		}
-		String classinfo_output = RemoteGreenstoneServer.getScriptOptions("classinfo.pl", classinfo_options);
+		String classinfo_output = Gatherer.remoteGreenstoneServer.getScriptOptions("classinfo.pl", classinfo_options);
 		xml = new StringBuffer(classinfo_output);
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/greenstone/Plugins.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/greenstone/Plugins.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/greenstone/Plugins.java	(revision 17612)
@@ -135,5 +135,5 @@
 		    pluginfo_options += "&collection=" + collection_name;
 		}
-		pluginfo_xml = RemoteGreenstoneServer.getScriptOptions("pluginfo.pl", pluginfo_options);
+		pluginfo_xml = Gatherer.remoteGreenstoneServer.getScriptOptions("pluginfo.pl", pluginfo_options);
 	    }
 	    else {
@@ -198,5 +198,5 @@
 		    pluginfo_options += "&collection=" + collection_name;
 		}
-		String pluginfo_output = RemoteGreenstoneServer.getScriptOptions("pluginfo.pl", pluginfo_options);
+		String pluginfo_output = Gatherer.remoteGreenstoneServer.getScriptOptions("pluginfo.pl", pluginfo_options);
 		xml = new StringBuffer(pluginfo_output);
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/greenstone3/ServletConfiguration.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/greenstone3/ServletConfiguration.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/greenstone3/ServletConfiguration.java	(revision 17612)
@@ -70,5 +70,5 @@
 
 	if (Gatherer.isGsdlRemote){
-	    if (RemoteGreenstoneServer.downloadWebXMLFile().equals("")) {
+	    if (Gatherer.remoteGreenstoneServer.downloadWebXMLFile().equals("")) {
 		System.err.println("Error: Could not download web.xml.");
 		System.exit(0);
@@ -89,5 +89,5 @@
 	this.sites = new ArrayList();
 	if (Gatherer.isGsdlRemote){
-	    String sites_on_server = RemoteGreenstoneServer.getSiteNames();
+	    String sites_on_server = Gatherer.remoteGreenstoneServer.getSiteNames();
 	    if (sites_on_server.equals("")) {
 		// !! Something went wrong : could not get names of the sites
Index: /gli/trunk/src/org/greenstone/gatherer/gui/ExplodeMetadataDatabasePrompt.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/gui/ExplodeMetadataDatabasePrompt.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/gui/ExplodeMetadataDatabasePrompt.java	(revision 17612)
@@ -274,5 +274,6 @@
 	    String collection_name = CollectionManager.getLoadedCollectionName();
 	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String metadata_file_relative_path = RemoteGreenstoneServer.getPathRelativeToDirectory(metadata_file, collection_directory_path);
+	    String metadata_file_relative_path = Gatherer.remoteGreenstoneServer.getPathRelativeToDirectory(
+                                                          metadata_file, collection_directory_path);
 	    command_parts_list.add("-file");
 	    command_parts_list.add(metadata_file_relative_path);
@@ -345,5 +346,6 @@
 		if (Gatherer.isGsdlRemote) {
 		    Utility.delete(metadata_file.getParentFile());
-		    RemoteGreenstoneServer.downloadCollectionFile(CollectionManager.getLoadedCollectionName(), metadata_file.getParentFile());
+		    Gatherer.remoteGreenstoneServer.downloadCollectionFile(
+                             CollectionManager.getLoadedCollectionName(), metadata_file.getParentFile());
 		}
 
Index: /gli/trunk/src/org/greenstone/gatherer/gui/GUIManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/gui/GUIManager.java	(revision 17612)
@@ -438,5 +438,5 @@
 		remote_greenstone_server_progress_panel.setLayout(new BorderLayout());
 		remote_greenstone_server_progress_panel.add(remote_greenstone_server_progress_label, BorderLayout.WEST);
-		remote_greenstone_server_progress_panel.add(RemoteGreenstoneServer.getProgressBar(), BorderLayout.CENTER);
+		remote_greenstone_server_progress_panel.add(Gatherer.remoteGreenstoneServer.getProgressBar(), BorderLayout.CENTER);
 		content_pane.add(remote_greenstone_server_progress_panel, BorderLayout.SOUTH);
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/gui/NewCollectionDetailsPrompt.java	(revision 17612)
@@ -259,5 +259,5 @@
 	// Remote collections that aren't shared have the user's username prefixed to the collection name
 	if (Gatherer.isGsdlRemote && personal_collection_button.isSelected()) {
-	    name_buffer = new StringBuffer(RemoteGreenstoneServer.getUsername() + "-" + name_buffer.toString());
+	    name_buffer = new StringBuffer(Gatherer.remoteGreenstoneServer.getUsername() + "-" + name_buffer.toString());
 	}
 
Index: /gli/trunk/src/org/greenstone/gatherer/gui/Preferences.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/gui/Preferences.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/gui/Preferences.java	(revision 17612)
@@ -826,5 +826,5 @@
 	    Configuration.save();
 	    if (Gatherer.isGsdlRemote && Gatherer.GS3 && site_changed ){
-		RemoteGreenstoneServer.downloadCollectionConfigurations();
+		Gatherer.remoteGreenstoneServer.downloadCollectionConfigurations();
 	    }
 	    // Refresh the GLI to account for the configuration changes
@@ -956,10 +956,10 @@
 		    if (Gatherer.c_man.getCollection()!=null){
 			File lock_file = new File(Gatherer.c_man.getLoadedCollectionDirectoryPath() + "gli.lck");
-			RemoteGreenstoneServer.deleteCollectionFile(Gatherer.c_man.getLoadedCollectionName(),lock_file);
+			Gatherer.remoteGreenstoneServer.deleteCollectionFile(Gatherer.c_man.getLoadedCollectionName(),lock_file);
 			Gatherer.g_man.closeCurrentCollection();
 		    }
 		    Configuration.site_name=site;
-		    RemoteGreenstoneServer.set_remote_greenstone_server_authentication_to_null();
-		    RemoteGreenstoneServer.downloadCollectionConfigurations();
+		    Gatherer.remoteGreenstoneServer.set_remote_greenstone_server_authentication_to_null();
+		    Gatherer.remoteGreenstoneServer.downloadCollectionConfigurations();
 		}
 	    }
Index: /gli/trunk/src/org/greenstone/gatherer/gui/ReplaceSrcDocWithHtmlPrompt.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/gui/ReplaceSrcDocWithHtmlPrompt.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/gui/ReplaceSrcDocWithHtmlPrompt.java	(revision 17612)
@@ -272,5 +272,5 @@
 	    String collection_name = CollectionManager.getLoadedCollectionName();
 	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String srcdoc_file_relative_path = RemoteGreenstoneServer.getPathRelativeToDirectory(
+	    String srcdoc_file_relative_path = Gatherer.remoteGreenstoneServer.getPathRelativeToDirectory(
 		this.srcdoc_files[fileNum], collection_directory_path); // preserves spaces in filename
 	    command_parts_list.add("-file");
@@ -382,5 +382,5 @@
 			// download the generated html file from the server side to put it 
 			// into the import directory on the client side
-			RemoteGreenstoneServer.downloadCollectionFile(
+			Gatherer.remoteGreenstoneServer.downloadCollectionFile(
 					      CollectionManager.getLoadedCollectionName(),
 					      new File(srcdoc_files[i].getParentFile(), htmlFile));
@@ -389,6 +389,6 @@
 			File assoc_folder = new File(srcdoc_files[i].getParentFile(), suffixlessFilename+"_files");
 			// If an associated_folder by such a name exists, download it
-			if(RemoteGreenstoneServer.exists(CollectionManager.getLoadedCollectionName(), assoc_folder)) {
-			  RemoteGreenstoneServer.downloadCollectionFile(
+			if(Gatherer.remoteGreenstoneServer.exists(CollectionManager.getLoadedCollectionName(), assoc_folder)) {
+			  Gatherer.remoteGreenstoneServer.downloadCollectionFile(
 			                        CollectionManager.getLoadedCollectionName(), assoc_folder);
 			}
Index: /gli/trunk/src/org/greenstone/gatherer/metadata/MetadataXMLFileManager.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/metadata/MetadataXMLFileManager.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/metadata/MetadataXMLFileManager.java	(revision 17612)
@@ -368,5 +368,6 @@
 
 	    // Upload the files modified since last time, then reset the list
-	    RemoteGreenstoneServer.uploadCollectionFiles(CollectionManager.getLoadedCollectionName(), (File[]) modified_metadata_xml_files.toArray(new File[0]));
+	    Gatherer.remoteGreenstoneServer.uploadCollectionFiles(
+                  CollectionManager.getLoadedCollectionName(), (File[]) modified_metadata_xml_files.toArray(new File[0]));
 	    modified_metadata_xml_files.clear();
 	}
Index: /gli/trunk/src/org/greenstone/gatherer/metadata/ProfileXMLFile.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/metadata/ProfileXMLFile.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/metadata/ProfileXMLFile.java	(revision 17612)
@@ -110,5 +110,5 @@
 	// This is inefficient but for simplicity we'll just upload the file every time it is changed
 	if (Gatherer.isGsdlRemote) {
-	    RemoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), this);
+	    Gatherer.remoteGreenstoneServer.uploadCollectionFile(CollectionManager.getLoadedCollectionName(), this);
 	}
 
Index: /gli/trunk/src/org/greenstone/gatherer/remote/ActionQueue.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/remote/ActionQueue.java	(revision 17612)
+++ /gli/trunk/src/org/greenstone/gatherer/remote/ActionQueue.java	(revision 17612)
@@ -0,0 +1,165 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Greenstone Librarian Interface application, part of 
+ * the Greenstone digital library suite from the New Zealand Digital 
+ * Library Project at the University of Waikato, New Zealand.
+ *
+ * Author: Michael Dewsnip, NZDL Project, University of Waikato
+ *
+ * Copyright (C) 2005 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+
+package org.greenstone.gatherer.remote;
+
+import java.io.*;
+import java.net.*;
+import java.util.*;
+import java.util.zip.*;
+import javax.swing.*;
+import java.io.ByteArrayOutputStream;
+import org.greenstone.gatherer.Configuration;
+import org.greenstone.gatherer.DebugStream;
+import org.greenstone.gatherer.Dictionary;
+import org.greenstone.gatherer.FedoraInfo;
+import org.greenstone.gatherer.GAuthenticator;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.collection.CollectionManager;
+import org.greenstone.gatherer.shell.GShell;
+import org.greenstone.gatherer.util.UnzipTools;
+import org.greenstone.gatherer.util.Utility;
+import org.apache.commons.httpclient.HttpClient;
+import org.apache.commons.httpclient.methods.PostMethod;
+import org.apache.commons.httpclient.methods.GetMethod;
+import org.apache.commons.httpclient.HttpException;
+import org.apache.commons.httpclient.methods.multipart.FilePart;
+import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
+import org.apache.commons.httpclient.methods.multipart.Part;
+import org.apache.commons.httpclient.methods.multipart.*;
+import org.apache.commons.httpclient.params.*;
+import org.apache.commons.httpclient.HttpStatus;
+
+// ----------------------------------------------------------------------------------------------------
+//   Part of the RemoteGreenstoneServer's QUEUE LAYER
+// ----------------------------------------------------------------------------------------------------
+
+// Moved here. Previously called RemoteGreenstoneServerActionQueue
+/** 
+ * A Thread that maintains a queue of RemoteGreenstoneServer Actions
+ * that are to be executed in FIFO fashion.
+*/
+class ActionQueue extends Thread
+{
+    /** The queue of waiting jobs. */
+    private ArrayList queue = null;
+    
+    
+    public ActionQueue()
+    {
+	if (Gatherer.isGsdlRemote) {
+	    queue = new ArrayList();
+	    start();
+	}
+    }
+    
+    
+    synchronized public void addAction(RemoteGreenstoneServerAction remote_greenstone_server_action)
+    {
+	queue.add(remote_greenstone_server_action);
+	notifyAll();
+    }
+    
+    
+    public int size()
+    {
+	return queue.size();
+    }
+    
+    
+    public void run()
+    {
+	boolean exit = false;
+	while (!exit) {
+	    // If there are jobs on the queue, get the next in line and process it
+	    if (queue.size() > 0) {
+		RemoteGreenstoneServerAction remote_greenstone_server_action = (RemoteGreenstoneServerAction) queue.get(0);
+		
+		try {
+		    remote_greenstone_server_action.perform();
+		    
+		    // No exceptions were thrown, so the action was successful
+		    remote_greenstone_server_action.processed_successfully = true;
+		}
+		catch (RemoteGreenstoneServerAction.ActionCancelledException exception) {
+		    remote_greenstone_server_action.processed_successfully = false;
+		    exit = true;
+		} 
+		catch(java.net.ConnectException exception) {
+		    if(exception.getMessage().trim().startsWith("Connection refused")) {
+			exit = true;
+		    } else {
+			DebugStream.printStackTrace(exception);
+		    }
+		    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Error", exception.getMessage()), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.ERROR_MESSAGE);
+		    remote_greenstone_server_action.processed_successfully = false;			
+		}
+		catch (FileNotFoundException exception) {
+		    // FileNotFoundException happens when there's no GS server at the user-provided
+		    // url (the address of gliserver.pl is wrong).
+		    exit = true;
+		    DebugStream.printStackTrace(exception);
+		    JOptionPane.showMessageDialog(Gatherer.g_man, 
+						  Dictionary.get("RemoteGreenstoneServer.Error", 
+								 "No gliserver.pl found. " + exception.getMessage()), 
+						  Dictionary.get("RemoteGreenstoneServer.Error_Title"), 
+						  JOptionPane.ERROR_MESSAGE);
+		    remote_greenstone_server_action.processed_successfully = false;
+		}
+		catch (Exception exception) {
+		    DebugStream.printStackTrace(exception);
+		    JOptionPane.showMessageDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Error", exception.getMessage()), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.ERROR_MESSAGE);
+		    remote_greenstone_server_action.processed_successfully = false;
+		}
+		
+		// We're done with this action, for better or worse
+		remote_greenstone_server_action.processed = true;
+		queue.remove(0);
+	    }
+	    
+	    // Otherwise the queue is empty
+	    else {
+		Gatherer.remoteGreenstoneServer.getProgressBar().setAction(null);
+		
+		// Wait until we are notify()ed by addAction that there is a new job on the queue
+		synchronized (this) {
+		    try {
+			wait();
+		    }
+		    catch (InterruptedException exception) { }
+		}
+	    }
+	    
+	}
+	// stop the gazillion annoying error messages when the connection was simply
+	// refused or when the user pressed Cancel in the opening dialog, by exitting
+	// cleanly in one go.
+	//if(exit == true) {
+	    //Gatherer.exit();
+	//}
+    }
+}
